"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Space = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _nativeProps = require("../../utils/native-props");

var _withDefaultProps = require("../../utils/with-default-props");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var classPrefix = "adm-space";
var Space = (0, _withDefaultProps.withDefaultProps)({
  direction: 'horizontal'
})(function (props) {
  var _classNames;

  var size = props.size,
      direction = props.direction;
  var sizeStyle = {};

  if (size) {
    var _ref = Array.isArray(size) ? size : [size, size],
        horizontalSize = _ref[0],
        verticalSize = _ref[1];

    sizeStyle = {
      '--vertical-size': typeof verticalSize === 'number' ? verticalSize + "px" : verticalSize,
      '--horizontal-size': typeof horizontalSize === 'number' ? horizontalSize + "px" : horizontalSize
    };
  }

  return (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(classPrefix, (_classNames = {}, _classNames[classPrefix + "-wrap"] = props.wrap, _classNames[classPrefix + "-block"] = props.block, _classNames[classPrefix + "-" + direction] = true, _classNames[classPrefix + "-align-" + props.align] = !!props.align, _classNames[classPrefix + "-justify-" + props.justify] = !!props.justify, _classNames)),
    style: sizeStyle
  }, _react["default"].Children.map(props.children, function (child) {
    return child !== null && child !== undefined && /*#__PURE__*/_react["default"].createElement("div", {
      className: classPrefix + "-item"
    }, child);
  })));
});
exports.Space = Space;